// SPDX-FileCopyrightText: Copyright 2024 shadPS4 Emulator Project
// SPDX-License-Identifier: GPL-2.0-or-later

// Generated By moduleGenerator
#include "common/logging/log.h"
#include "core/libraries/error_codes.h"
#include "core/libraries/libs.h"
#include "signindialog.h"

namespace Libraries::SigninDialog {

s32 PS4_SYSV_ABI sceSigninDialogInitialize() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI sceSigninDialogOpen() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called");
    return ORBIS_OK;
}

Status PS4_SYSV_ABI sceSigninDialogGetStatus() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called, return 'finished' status");
    return Status::FINISHED;
}

Status PS4_SYSV_ABI sceSigninDialogUpdateStatus() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called, return 'finished' status");
    return Status::FINISHED;
}

s32 PS4_SYSV_ABI sceSigninDialogGetResult() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI sceSigninDialogClose() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called");
    return ORBIS_OK;
}

s32 PS4_SYSV_ABI sceSigninDialogTerminate() {
    LOG_ERROR(Lib_SigninDialog, "(STUBBED) called");
    return ORBIS_OK;
}

void RegisterLib(Core::Loader::SymbolsResolver* sym) {
    LIB_FUNCTION("mlYGfmqE3fQ", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogInitialize);
    LIB_FUNCTION("JlpJVoRWv7U", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogOpen);
    LIB_FUNCTION("2m077aeC+PA", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogGetStatus);
    LIB_FUNCTION("Bw31liTFT3A", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogUpdateStatus);
    LIB_FUNCTION("nqG7rqnYw1U", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogGetResult);
    LIB_FUNCTION("M3OkENHcyiU", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogClose);
    LIB_FUNCTION("LXlmS6PvJdU", "libSceSigninDialog", 1, "libSceSigninDialog", 1, 1,
                 sceSigninDialogTerminate);
};

} // namespace Libraries::SigninDialog
